﻿package {
	import com.kagedenwa.*;
	import com.hurlant.util.Base64;
	import fl.controls.Button;
	import fl.controls.TextArea;
	import flash.events.*;
	import flash.display.*;
	import flash.media.*;
	public class EncodeCamera extends Sprite {
		private var cam:Camera; // カメラ
		private var video:Video; // カメラからの画像を表示
		private var bmp:Bitmap; // 表示
		private var bmp_decoded:Bitmap;
		private var shadow_decoded:Shadow;
		private var _textAreaEncoded:TextArea;
		private var _buttonBg:Button;
		private var _buttonLoad:Button;
		private var _buttonSave:Button;
		private var subtractor:Subtractor;
		
		public function EncodeCamera() {
			stage.scaleMode = StageScaleMode.EXACT_FIT; // 伸縮する
			// stage.scaleMode = StageScaleMode.NO_SCALE; // 伸縮しない
			stage.align = StageAlign.TOP_LEFT; // 左上から
			
			link_ide_obj() // IDEが生成したオブジェクトを関連づけ
			
			cam = Camera.getCamera();
			cam.setMode(800,600,24,true);// 24FPS
			cam.setQuality(0,100);
			
			video = new Video(200,150); // bitmap計算用の小さいビデオ
			video.attachCamera(cam);
			//this.addChild(video); // videoを表示
			subtractor = new Subtractor();
			subtractor.threshold = 30;
			
			_buttonBg.addEventListener(MouseEvent.CLICK, snapShotBg); // 撮影ボタンの処理
			_buttonLoad.addEventListener(MouseEvent.CLICK, decode); // 再生ボタン
			_buttonSave.addEventListener(MouseEvent.CLICK, encode);
			bmp = new Bitmap(subtractor.shadow.getBitmapData()); // BitmapDataをBitampに登録
			this.addChild(bmp); // Bitmapを表示
			shadow_decoded = new Shadow();
			bmp_decoded = new Bitmap(shadow_decoded.getBitmapData());
			this.addChild(bmp_decoded);
			bmp_decoded.x = bmp.width+10;
			
			this.addEventListener(Event.ENTER_FRAME, makeShadow); // 毎フレーム実行
		}
		
		/* IDEが生成したオブジェクトを関連づけ */
		public function link_ide_obj() {
			_textAreaEncoded = textAreaEncoded;
			_buttonLoad = buttonLoad;
			_buttonSave = buttonSave;
			_buttonBg = buttonBg;
		}
		
		public function snapShotBg(e:Event){
			subtractor.bg.draw(video);
		}
		
		public function makeShadow(e:Event) {
			subtractor.bmd.draw(video);
			subtractor.subtract();
			subtractor.display();
		}
		
		public function encode(e:Event){
			_textAreaEncoded.text = Base64.encodeByteArray(subtractor.shadow.getByteArray());
		}
		
		public function decode(e:Event) {
			shadow_decoded.setByteArray(Base64.decodeToByteArray(_textAreaEncoded.text));
			shadow_decoded.updateBitmapData();
		}
		
	}
}